killboard = {}

--------------------------------------------------------------------------
killboard.Version = "1.00"               -- See bottom of file for changelog
killboard.Asof    = "2023/03"
killboard.DEBUG   = false                -- Control DEBUG messaging during run 
--------------------------------------------------------------------------
--------------------------------------------------------------------------

killboard.totalKills = 0
killboard.killTypes =  {}                    -- keep a table of types killed


function killboard.showKills (args, currtime)
        if killboard.DEBUG then
	   trigger.action.outText("showKills: @ " .. currtime, 10)
	end
        
	local keys = {}                      -- This intermediary table will help us sort our actype table
	for k in pairs (killboard.killTypes) do  table.insert(keys, k)  end
	table.sort(keys)

	trigger.action.outText("  A/C Type            Kill Count", 20)
	local kills	
	for _, actype in ipairs (keys) do
	   kills =  killboard.killTypes[actype]	
	   if string.len(actype) < 7 then  
	      actype = actype .. "  ...  .  ...   "  
           else
	      actype = actype .. "  ...   "  
           end
	   trigger.action.outText("  " .. actype .. "       " .. kills, 20)
        end
        trigger.action.outText("  Total Kills:    ...         " .. killboard.totalKills, 20)
	return currtime + 90
end


function killboard.addKill (actype)
	if string.upper(actype) == "DEBUG" then
	   killboard.DEBUG = true
	   return
        end   
        
	if killboard.DEBUG then
	   trigger.action.outText("addKills: ==> " .. actype, 10)
	end

	killboard.totalKills = killboard.totalKills + 1

	if killboard.killTypes[actype] == nil then
           killboard.killTypes[actype] = 1
        else
           killboard.killTypes[actype] = killboard.killTypes[actype] + 1		
        end
	return
end


do
	trigger.action.outText("KillBoard Script  v" .. killboard.Version .. " (" .. killboard.Asof .. ") -- Loaded... ", 5)

	if killboard.DEBUG then
	   trigger.action.outText("DEBUG Mode is On...", 5)
	end

	timer.scheduleFunction(killboard.showKills, nil, timer.getTime() + 90)
end


---------------------------------------------------------------------------------------------------
----------                         Script Changelog & Notes                              ----------
---------------------------------------------------------------------------------------------------
--  VER      WHEN       WHAT
---------------------------------------------------------------------------------------------------
--
--  1.00   2023/03/20   Basic counter script for aircraft kills  (created for Marianas Tanker Shoot)
--
---------------------------------------------------------------------------------------------------
